#pragma once

#include "GuiParent.h"

template<typename T> class CGuiButton : public CGuiParent
{
	T* m_pcTemplateClass;
	void (T::*m_ActFunc)();
public:
	CGuiButton(int x, int y, int width, int height, void (T::*actfunc)(), T* templateclass) : CGuiParent(x, y, width, height), m_ActFunc(actfunc), m_pcTemplateClass(templateclass)
	{
	}

	virtual void Draw() = 0;
	virtual bool MouseButtonDown(MOUSE_BUTTON eMouseButton, int x, int y)
	{
		if(eMouseButton == MOUSEBUTTON_LEFT)
		{
			if(m_ActFunc)
			{
				(m_pcTemplateClass->*m_ActFunc)();
			}
		}
		return TRUE;	
	}
};