#pragma once

#include "GuiParent.h"
#include "Map.h"
#include <vector>
#include <queue>

class CGuiManage
{
protected:
	CGuiParent* m_pcFocusGui;
	CGuiParent* m_pcPreemitiveGui;
	CMap<int, CGuiParent*> m_mapGuiParent;
	std::vector<CGuiParent*> m_vGuiParent;
	std::vector<CGuiParent*>::iterator it;
	std::vector<CGuiParent*>::reverse_iterator reverse_it;
	bool m_bPreemitiveMode;
	int* m_piScrollX,* m_piScrollY;
	std::queue<int>m_qIdx;

public:
	CGuiManage(int* piScrollX = NULL, int* piScrollY = NULL, bool m_bPreemitiveMode = false);
	virtual ~CGuiManage();

	int GetIdx(){
		if(m_qIdx.empty()){
			return -1;
		}
		int idx = m_qIdx.front();
		m_qIdx.pop();
		return idx;
	}
	bool AddGui(CGuiParent* guiparent);
	bool RemoveGui(int idx);
	void SetPreemitiveMode(bool bPreemitiveMode){m_bPreemitiveMode = bPreemitiveMode;}
	void SetPreemitiveGui(CGuiParent* gui){
		m_pcPreemitiveGui = gui;
		if(m_pcPreemitiveGui)
		{
			SetPreemitiveMode(true);
		}
		else
		{
			SetPreemitiveMode(false);
		}
	}

	virtual bool PreemitiveDraw(); // ׸ . 

	void AdjustPos(int &x, int &y);

	void SetMouseOver(CGuiParent* gui); //Ķͷ ѱ gui  Ű   !  Լ ȣϸ it ٲ. ȣ ϰ    

	virtual bool MouseButtonDown(MOUSE_BUTTON eMouseButton, int x, int y);
	virtual bool MouseButtonUp(MOUSE_BUTTON eMouseButton,int x, int y);

	virtual bool KeyDown(int keyvalue);
	virtual bool KeyUp(int keyvalue);
	virtual bool MouseMove(int x, int y); //콺 

	virtual void Draw();

	CGuiParent* GetGui(int idx);
	static CGuiManage* GetInstancePtr(){
		static CGuiManage guimanage;
		return &guimanage;
	}
};

inline CGuiManage* GetGuiManage()
{
	return CGuiManage::GetInstancePtr() ;
}