#pragma once

#include "CharacterParent.h"

class CCharacter : public CCharacterParent
{
	CGuiParent* m_pcGui;
	
public:
	CCharacter(int characternumber, SDL_Surface* tilesurface, int tilex, int tiley, int moveabletile = 3, int attackabletile = 5);
	virtual ~CCharacter();

	void SetGui(CGuiParent* gui){
		m_pcGui = gui;
	}

	virtual void SetCharacterState(CHARACTER_STATE characterstate){
		switch(characterstate)
		{
		case CHARACTERSTATE_MENU:
			if(m_pcGui)
			{
				m_pcGui->SetX(GetTileX()*  GetWidth() + GetWidth());
				m_pcGui->SetY(GetTileY()*  GetHeight());
				m_pcGui->SetVisible(TRUE);
			}
			break;
		case CHARACTERSTATE_MOVE:
			if(m_pcGui)
			{
				m_pcGui->SetVisible(FALSE);
			}
			break;
		case CHARACTERSTATE_ATTACK:
		case CHARACTERSTATE_INFO:
		case CHARACTERSTATE_NONE:
			if(m_pcGui)
			{
				m_pcGui->SetVisible(FALSE);
			}
			break;
		}
		__super::SetCharacterState(characterstate);
	}

	virtual bool isSelect(){return true;}
};