#include "CharacterManage.h"
#include "GameMain.h"

CCharacterManage::CCharacterManage()
{
	m_pcSelectCharacterParent = NULL;
}

CCharacterManage::~CCharacterManage()
{
	m_mapCharacterParent.FreePtr();
}

bool CCharacterManage::AddCharacterParent(CCharacterParent* characterparent)
{
	return m_mapCharacterParent.Add(characterparent->GetCharacterNumber(), characterparent);
}

bool CCharacterManage::RemoveCharacterParent(int characternumber)
{
	return m_mapCharacterParent.RemovePtr(characternumber);
}

void CCharacterManage::Draw()
{
	for(it = m_mapCharacterParent.m_Map.begin(); it != m_mapCharacterParent.m_Map.end(); ++it)
	{
		CCharacterParent* characterparent = it->second;
		characterparent->Draw();
	}
}

CCharacterParent* CCharacterManage::GetCharacterParent(int tilex, int tiley)
{
	for(it = m_mapCharacterParent.m_Map.begin(); it != m_mapCharacterParent.m_Map.end(); ++it)
	{
		CCharacterParent* characterparent = it->second;
		if(characterparent->GetTileX() == tilex && characterparent->GetTileY() == tiley)
		{
			return characterparent;
		}
	}
	return NULL;
}

bool CCharacterManage::MoveCharacterParent(CCharacterParent* characterparent, int tilex, int tiley)
{
	if(!characterparent->isMove())
		return false;

	if(GetCharacterParent(tilex, tiley))
		return false;

	if(abs(characterparent->GetTileX() - tilex) + abs(characterparent->GetTileY() - tiley) < characterparent->GetMoveableTile())
	{
		characterparent->SetTilePos(tilex, tiley);
		return true;
	}
	return false;
}

CCharacterParent* CCharacterManage::SelectCharacter(int tilex, int tiley)
{
	CCharacterParent* characterparent = GetCharacterParent(tilex, tiley);
	if(characterparent && characterparent->isSelect())
	{
		return characterparent;
	}
	return NULL;
}

bool CCharacterManage::isValidArea(CCharacterParent* character1, CCharacterParent* character2, int area)
{
	if(character1 == NULL || character2 == NULL)
		return false;

	if(character1 == character2)
		return false;

	if(area <= abs(character1->GetTileX() - character2->GetTileX()) + abs(character1->GetTileY() - character2->GetTileY()))
		return false;

	return true;
}